unit Fm_DDE;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DdeMan, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    DdeClientItem1: TDdeClientItem;
    DdeClientConv1: TDdeClientConv;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    DDEOpen : Boolean;
    Procedure Init_DDE;
   public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
   Init_DDE;
end;

{--------------------------------------------}
{   DDE innitialization code for Delphi      }
{           by Michael Owen, W9IP            }
{  Northern Lights Software Associates       }
{--------------------------------------------}
Procedure TForm1.Init_DDE;
Var pC          : array[0..20] of Char;
    OK, BailOut : Boolean;
Const Service = 'NFW32';
      Topic   = 'NFW_DATA';
      Item    = 'NFW_SERVER';
Begin
  OK      := False;
  DDEOpen := False;
  BailOut := False;
  DDEClientConv1.SetLink(Service,Topic);
  While NOT OK do
    If DdeClientConv1.OpenLink then begin
      StrPCopy(pC,'TUNE ON');
      OK := DDEClientConv1.PokeData(Item,pC);
    end else begin
      OK := False;
      Case MessageDlg('Unable to establish link with Nova for Windows.'
            +#13+'Do you want to try again?', mtWarning,[mbYes,mbNo,mbAbort,mbHelp], 5) of
        mrNo : Break;
        mrAbort : Begin
                    BailOut := True;
                    Break;
                  end;
       end; {case}
  end;  {While}
  If BailOut then Application.Terminate;
  DDEOpen := OK;
  If DDEOpen then begin
     Label1.Caption := 'NovaTune has a good DDE link'+#13+'with Nova for Windows';
      end else begin
      Label1.Caption := 'No link';
      end;
  End;
{----------------------------------------------------}

end.
